#! /usr/bin/perl

use strict;

my $i;
my $j;
my $alpha = 0.0;
my $beta = 0.0;
my $PI = 3.1415927;
my $x = 0.0;
my $y = 0.0;
my $z = 0.0;
my $factor = 1.00;

my $x_temp = 0.0;
my $y_temp = 0.0;

#my $drill_d = 1.5;
my $drill_d = 2.99;
my $drill_r = $drill_d/2.0;


#my $cut_gap = 3.0;  #Width of cut gaps, 1.5mm drill
my $cut_gap = 4.5;   #Width of cut gaps, 3.0mm drill
my $cut_gap_2 = 9.0; #Position of cut gap



my $body_l = 200;
my $body_w = 120;
my $body_h = 25;
my $body_h_2 = 10;
my $body_edge = 5;

my $battery_w = 45;
my $battery_l = 100;
my $battery_h = 20;
my $battery_h_2 = 40;
my $battery_flap = 10;
my $battery_edge = 5;

my $battery_mount_x = ($battery_w + $battery_flap)/2.0 + $battery_h + $drill_r * 1.5;
my $battery_mount_y = $battery_l/2.0 - 10.0;

my $battery_lock_x = ($battery_w + $battery_h)/2.0 + $drill_r * 1.5;
my $battery_lock_y = $battery_l/2.0 - 5.0;

my $screw_hole_r = (3.00-$drill_d)/2.0;

my $holes_grid_x = 12;
my $holes_grid_y = 20;

my $x_distance = $battery_w/2.0 + $battery_h + $battery_flap + $drill_d * 1.5;
my $y_distance = $battery_l/2.0 + $battery_h_2 + $drill_r;



my $feed_rate = 3.000;
my $feed_rate_material = 1.500;
my $feed_rate_empty = 2.500;
my $Z_up = 3.000;      #Highest point of tool
my $Z_down = -1.000;
my $Z_down_1 = -1.500; #Depth bend edges
my $Z_down_2 = -2.000; #Depth cut edges
my $Z_down_3 = -4.500; #Deepest cut through material
my $z_step = 4.5;      #Cut depth per run
my $z_step_temp = $z_step;

open(FILEOUT,'> battery.gcode') || die "Can not open " . "battery.gcode!\n";


  print FILEOUT "M3\n";#Turn on Spindle
  print FILEOUT "M8\n";#Turn on coolant


  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  $x = -$battery_w / 2.0 - $drill_r;
  $y = -$battery_l/2.0 - $drill_r;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


#=pod

  #Bend edges
  print FILEOUT ";Bend edges\n";
  if($z_step_temp > -$Z_down_1){
    $z_step_temp = -$Z_down_1;
  }
  for($Z_down = -$z_step_temp; $Z_down >= $Z_down_1; $Z_down -= $z_step_temp){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;

    $x = -$battery_w / 2.0 - $drill_r;
    $y = -$battery_l/2.0 - $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_l/2.0 + $drill_r;
    $x = -$battery_w / 2.0 - $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_l/2.0 + $drill_r;
    $x = $battery_w / 2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -$battery_l/2.0 - $drill_r;
    $x = +$battery_w / 2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = -$battery_w / 2.0 - $drill_r;
    $y = -$battery_l/2.0 - $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down - $z_step < $Z_down_1 && $Z_down !=  $Z_down_1){
      $Z_down = $Z_down_1 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  $x = -$battery_w / 2.0 - $battery_h - $drill_r;
  $y = -$battery_l/2.0 - $drill_r;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


  if($z_step_temp > -$Z_down_1){
    $z_step_temp = -$Z_down_1;
  }
  for($Z_down = -$z_step_temp; $Z_down >= $Z_down_1; $Z_down -= $z_step_temp){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;

    $x = -$battery_w / 2.0 - $battery_h - $drill_r * 1.5;
    $y = -$battery_l/2.0 - $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_l/2.0 + $drill_r;
    $x = -$battery_w / 2.0 - $battery_h - $drill_r * 1.5;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_l/2.0 + $drill_r;
    $x = $battery_w / 2.0 + $battery_h + $drill_r * 1.5;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -$battery_l/2.0 - $drill_r;
    $x = +$battery_w / 2.0 + $battery_h + $drill_r * 1.5;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -$battery_l/2.0 - $drill_r;
    $x = +$battery_w / 2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -$battery_l/2.0 - $drill_r;
    $x = -$battery_w / 2.0 - $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";



    if($Z_down - $z_step < $Z_down_1 && $Z_down !=  $Z_down_1){
      $Z_down = $Z_down_1 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
#=cut


  &screwHoles(-$battery_lock_x, $battery_lock_y, 0, 0);
  &screwHoles($battery_lock_x, $battery_lock_y, 0, 0);

  #Cutting outline
  print FILEOUT ";Outline\n";

  $x = $battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r;
  $y = $battery_l/2.0 - $battery_edge + $drill_r;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $feed_rate = $feed_rate_material;
    $z = $Z_down;

    $x = $battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r;
    $y = $battery_l/2.0 - $battery_edge + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r - $battery_edge;
    $y = $battery_l/2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $battery_w / 2.0 + $drill_r;
    $y = $battery_l/2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $battery_w / 2.0 + $drill_r;
    $y = $battery_l/2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down < $Z_down_2){#Cut gap

      $x = $cut_gap;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = 0.0;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $x = -($battery_w / 2.0 + $drill_r);
    $x = $x * $factor + $x_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_l/2.0 + $drill_r;
    $x = -($battery_w / 2.0 + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_l/2.0 + $drill_r;
    $x = -($battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r - $battery_edge);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_l/2.0 + $drill_r - $battery_edge;
    $x = -($battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_mount_y;
    $x = -($battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_mount_y;
    $x = -($battery_mount_x);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_mount_y;
    $x = -($battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down < $Z_down_2){#Cut gap

      $y = $battery_l/4.0 - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $y = $battery_l/4.0 - $cut_gap - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down < $Z_down_2){#Cut gap

      $y = -$battery_l/4.0 - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $y = -$battery_l/4.0 - $cut_gap - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $y = -$battery_mount_y;
    $x = -($battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -$battery_mount_y;
    $x = -($battery_mount_x);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -$battery_mount_y;
    $x = -($battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($battery_l/2.0 + $drill_r - $battery_edge);
    $x = -($battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($battery_l/2.0 + $drill_r);
    $x = -($battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r - $battery_edge);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($battery_l/2.0 + $drill_r);
    $x = -($battery_w / 2.0 + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($battery_l/2.0 + $battery_h_2 + $drill_r);
    $x = -($battery_w / 2.0 + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down < $Z_down_2){#Cut gap

      $x = 0.0;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $cut_gap;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $y = -($battery_l/2.0 + $battery_h_2 + $drill_r);
    $x = $battery_w / 2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    $y = -($battery_l/2.0 + $drill_r);
    $x = $battery_w / 2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($battery_l/2.0 + $drill_r);
    $x = $battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r - $battery_edge;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($battery_l/2.0 + $drill_r - $battery_edge);
    $x = $battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($battery_mount_y);
    $x = $battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($battery_mount_y);
    $x = $battery_mount_x;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($battery_mount_y);
    $x = $battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down < $Z_down_2){#Cut gap

      $y = -$battery_l/4.0 - $cut_gap - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $y = -$battery_l/4.0 - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down < $Z_down_2){#Cut gap

      $y = $battery_l/4.0 - $cut_gap - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $y = $battery_l/4.0 - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $y = $battery_mount_y;
    $x = $battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_mount_y;
    $x = $battery_mount_x;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $battery_mount_y;
    $x = $battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";



    $y = $battery_l/2.0 + $drill_r - $battery_edge;
    $x = $battery_w / 2.0 + $battery_h + $battery_flap + $drill_d + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";




  #Back to zero
  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  $x = 0;
  $y = 0;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  print FILEOUT "M5\n";#Turn off spindle
  print FILEOUT "M9\n";#Turn off coolant



close(FILEOUT);

exit(0);


#++++++++++++++++++++++ Screw holes ++++++++++++++++++++++++++++++++++++
sub screwHoles(){

  my $nut_r = 5.3/2.0 - $drill_r;
  my $r = $nut_r;
  my $nut_depth = -1.9;

  if($_[2] == 0){
    $r = $screw_hole_r;
  }

  $x = $_[0] + sin(0.0) * ($r)/2.0;
  $y = $_[1] + cos(0.0) * ($r)/2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    if($Z_down < $nut_depth && $r == $nut_r){
      $Z_down = $nut_depth;
    }
    $z = $Z_down;
    $feed_rate = $feed_rate_material;
    for($alpha = 0.0; $alpha <= $PI * 2.0; $alpha += 0.01){
      $x = $_[0] + sin($alpha) * $r;
      $y = $_[1] + cos($alpha) * $r;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    }

    if($Z_down == $nut_depth){
      $r = $screw_hole_r;
      $x = $_[0] + sin(0.0) * $r;
      $y = $_[1] + cos(0.0) * $r;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z=$Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

}
