#! /usr/bin/perl

use strict;

my $i;
my $j;
my $alpha = 0.0;
my $beta = 0.0;
my $PI = 3.1415927;
my $x = 0.0;
my $y = 0.0;
my $z = 0.0;
my $factor = 1.00;

my $x_temp = 0.0;
my $y_temp = 0.0;

#my $drill_d = 1.5;
my $drill_d = 2.99;
my $drill_r = $drill_d/2.0;


#my $cut_gap = 3.0;  #Width of cut gaps, 1.5mm drill
my $cut_gap = 4.5;   #Width of cut gaps, 3.0mm drill
my $cut_gap_2 = 9.0; #Position of cut gap



my $body_l = 200;
my $body_w = 120;
my $body_h = 25;
my $body_h_2 = 10;
my $body_edge = 5;

my $holes_grid_x = 12;
my $holes_grid_y = 20;

my $servo_l = 41;
my $servo_w = 20;
my $servo_x = $body_w/2.0+$drill_d*1.5;
my $servo_y = $body_l/2.0-11.0;
my $servo_cable_w = 4;
my $servo_cable_l = 3;
my $servo_mount_x = ($servo_w - 10.17)/2.0;
my $servo_mount_y = 4.81 - 0.5;
my $screw_hole_r = (3.00-$drill_d)/2.0;

my $rear_axle_x = $body_w/2.0 + $servo_w / 2.0 + $drill_d;
my $rear_axle_y = -$body_l/2.0 + 5.0;
my $rear_axle_l = 25.0;
my $rear_axle_d = 4.0;


my $x_distance = $body_w/2.0 + $body_h + $drill_d * 1.5;
my $y_distance = $body_l/2.0 + $body_h_2 + $drill_d * 1.5;



my $feed_rate = 2.000;
my $feed_rate_material = 1.500;
my $feed_rate_empty = 2.500;
my $Z_up = 3.000;      #Highest point of tool
my $Z_down = -1.000;
my $Z_down_1 = -1.500; #Depth bend edges
my $Z_down_2 = -2.000; #Depth cut edges
my $Z_down_3 = -4.500; #Deepest cut through material
my $z_step = 4.5;      #Cut depth per run
my $z_step_temp = $z_step;

open(FILEOUT,'> body.gcode') || die "Can not open " . "body.gcode!\n";


  print FILEOUT "M3\n";#Turn on Spindle
  print FILEOUT "M8\n";#Turn on coolant


  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  $x = -$body_w / 2.0 - $drill_r;
  $y = -$body_l/2.0 - $drill_r;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


#=pod

  #Bend edges
  print FILEOUT ";Bend edges\n";
  if($z_step_temp > -$Z_down_1){
    $z_step_temp = -$Z_down_1;
  }
  for($Z_down = -$z_step_temp; $Z_down >= $Z_down_1; $Z_down -= $z_step_temp){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;

    $x = -$body_w / 2.0 - $drill_r;
    $y = -$body_l/2.0 - $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $body_l/2.0 + $drill_r;
    $x = -$body_w / 2.0 - $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $body_l/2.0 + $drill_r;
    $x = $body_w / 2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -$body_l/2.0 - $drill_r;
    $x = +$body_w / 2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = -$body_w / 2.0 - $drill_r;
    $y = -$body_l/2.0 - $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down - $z_step < $Z_down_1 && $Z_down !=  $Z_down_1){
      $Z_down = $Z_down_1 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
#=cut

  #Servo cuts
  print FILEOUT ";Servo cuts\n";
  &Servo(-$body_w-$servo_w-$drill_d*2.0, 0, 0.5, 1);
  &Servo(0, 0, 1, 0.5);

#=pod
  #Rear axle cut

  $x = $rear_axle_x;
  $y = $rear_axle_y;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $feed_rate = $feed_rate_material;
    $z = $Z_down;

    $x = $rear_axle_x;
    $y = $rear_axle_y;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $rear_axle_x;
    $y = $rear_axle_y + $rear_axle_l - $drill_d;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $rear_axle_x + $rear_axle_d - $drill_d;
    $y = $rear_axle_y + $rear_axle_l - $drill_d;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $rear_axle_x + $rear_axle_d - $drill_d;
    $y = $rear_axle_y;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";



    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  $x = -$rear_axle_x;
  $y = $rear_axle_y;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $feed_rate = $feed_rate_material;
    $z = $Z_down;

    $x = -$rear_axle_x;
    $y = $rear_axle_y;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = -$rear_axle_x;
    $y = $rear_axle_y + $rear_axle_l - $drill_d;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = -($rear_axle_x + $rear_axle_d - $drill_d);
    $y = $rear_axle_y + $rear_axle_l - $drill_d;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = -($rear_axle_x + $rear_axle_d - $drill_d);
    $y = $rear_axle_y;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";



    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


  #Mount holes grid

  for($j=0; $j<$holes_grid_y; $j++){
    for($i=0; $i<$holes_grid_x; $i++){
      $x_temp = ($i + 0.5) * $body_w / ($holes_grid_x) - $body_w/2.0;
      $y_temp = ($j + 0.5) * $body_l / ($holes_grid_y) - $body_l/2.0;
      &screwHoles($x_temp, $y_temp, 0);
    }
    $j++;
    if($j<$holes_grid_y){
      for($i=$holes_grid_x-1; $i>-1; $i--){
        $x_temp = ($i + 0.5) * $body_w / ($holes_grid_x) - $body_w/2.0;
        $y_temp = ($j + 0.5) * $body_l / ($holes_grid_y) - $body_l/2.0;
        &screwHoles($x_temp, $y_temp, 0);
      }
    }
  }
#=cut

  #Cutting outline
  print FILEOUT ";Outline\n";

  $x = $body_w / 2.0 + $body_h + $drill_d + $drill_r;
  $y = $body_l/2.0 - $body_edge + $drill_r;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $feed_rate = $feed_rate_material;
    $z = $Z_down;

    $x = $body_w / 2.0 + $body_h + $drill_d + $drill_r;
    $y = $body_l/2.0 - $body_edge + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $body_w / 2.0 + $body_h + $drill_d + $drill_r - $body_edge;
    $y = $body_l/2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $body_w / 2.0 + $drill_r;
    $y = $body_l/2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $body_w / 2.0 + $drill_r;
    $y = $body_l/2.0 + $body_h_2 + $drill_d + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down < $Z_down_2){#Cut gap

      $x = $cut_gap;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = 0.0;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $x = -($body_w / 2.0 + $drill_r);
    $x = $x * $factor + $x_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $body_l/2.0 + $drill_r;
    $x = -($body_w / 2.0 + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $body_l/2.0 + $drill_r;
    $x = -($body_w / 2.0 + $body_h + $drill_d + $drill_r - $body_edge);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $body_l/2.0 + $drill_r - $body_edge;
    $x = -($body_w / 2.0 + $body_h + $drill_d + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down < $Z_down_2){#Cut gap

      $y = $body_l/3.0 - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $y = $body_l/3.0 - $cut_gap - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down < $Z_down_2){#Cut gap

      $y = -$body_l/3.0 - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $y = -$body_l/3.0 - $cut_gap - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $y = -($body_l/2.0 + $drill_r - $body_edge);
    $x = -($body_w / 2.0 + $body_h + $drill_d + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($body_l/2.0 + $drill_r);
    $x = -($body_w / 2.0 + $body_h + $drill_d + $drill_r - $body_edge);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($body_l/2.0 + $drill_r);
    $x = -($body_w / 2.0 + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($body_l/2.0 + $body_h_2 + $drill_d + $drill_r);
    $x = -($body_w / 2.0 + $drill_r);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down < $Z_down_2){#Cut gap

      $x = 0.0;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $cut_gap;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $y = -($body_l/2.0 + $body_h_2 + $drill_d + $drill_r);
    $x = $body_w / 2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    $y = -($body_l/2.0 + $drill_r);
    $x = $body_w / 2.0 + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($body_l/2.0 + $drill_r);
    $x = $body_w / 2.0 + $body_h + $drill_d + $drill_r - $body_edge;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = -($body_l/2.0 + $drill_r - $body_edge);
    $x = $body_w / 2.0 + $body_h + $drill_d + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down < $Z_down_2){#Cut gap

      $y = -$body_l/3.0 - $cut_gap - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $y = -$body_l/3.0 - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down < $Z_down_2){#Cut gap

      $y = $body_l/3.0 - $cut_gap - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $y = $body_l/3.0 - $drill_r;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }


    $y = $body_l/2.0 + $drill_r - $body_edge;
    $x = $body_w / 2.0 + $body_h + $drill_d + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";




  #Back to zero
  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  $x = 0;
  $y = 0;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  print FILEOUT "M5\n";#Turn off spindle
  print FILEOUT "M9\n";#Turn off coolant



close(FILEOUT);

exit(0);


#+++++++++++++++++++++++ Servo cut +++++++++++++++++++++++++++++++++++++

sub Servo(){

  #Cutting Servo holes
  $y = $servo_y + $_[1];
  $x = $servo_x + $_[0];
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $feed_rate = $feed_rate_material;
    $z = $Z_down;

    $y = $servo_y + $_[1];
    $x = $servo_x + $_[0] - $drill_d * $_[2];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down < $Z_down_2){#Cut gap

      $x = $servo_x + $_[0] - $drill_d * $_[2];
      $y = $servo_y - $servo_l/2.0 + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $servo_x + $_[0] - $drill_d * $_[2];
      $y = $servo_y - $servo_l/2.0 - $cut_gap + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $y = $servo_y - $servo_l + $drill_d + $_[1];
    $x = $servo_x + $_[0] - $drill_d * $_[2];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $servo_y - $servo_l + $drill_d + $_[1];
    $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down < $Z_down_2){#Cut gap

      $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];
      $y = $servo_y - $servo_l*4.0/5.0 - $cut_gap + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];;
      $y = $servo_y - $servo_l*4.0/5.0 + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down < $Z_down_2){#Cut gap

      $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];;
      $y = $servo_y - $servo_l/5.0 - $cut_gap + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];;
      $y = $servo_y - $servo_l/5.0 + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $y = $servo_y + $_[1];
    $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    #cable cut
    $y = $servo_y + $_[1];
    $x = $servo_x + $servo_w - $drill_d - ($servo_w-$servo_cable_w)/2.0 + $_[0];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $servo_y + $servo_cable_l + $_[1];
    $x = $servo_x + $servo_w - $drill_d - ($servo_w-$servo_cable_w)/2.0 + $_[0];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $servo_y + $servo_cable_l + $_[1];
    $x = $servo_x + ($servo_w-$servo_cable_w)/2.0 + $_[0];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $servo_y + $_[1];
    $x = $servo_x + ($servo_w-$servo_cable_w)/2.0 + $_[0];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    $y = $servo_y + $_[1];
    $x = $servo_x + $_[0];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }


  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

#=pot
  #Holes servo mount
  $x_temp = $servo_x + $servo_mount_x - $drill_r + $_[0];
  $y_temp = $servo_y + $servo_mount_y + $drill_r + $_[1];

  &screwHoles($x_temp, $y_temp, 0);

  #Holes servo mount
  $x_temp = $servo_x + $servo_w - $servo_mount_x - $drill_r + $_[0];
  $y_temp = $servo_y + $servo_mount_y + $drill_r + $_[1];

  &screwHoles($x_temp, $y_temp, 0);

  #Holes servo mount
  $x_temp = $servo_x + $servo_w - $servo_mount_x - $drill_r + $_[0];
  $y_temp = $servo_y - $servo_l - $servo_mount_y + $drill_r + $_[1];

  &screwHoles($x_temp, $y_temp, 0);

  #Holes servo mount
  $x_temp = $servo_x + $servo_mount_x - $drill_r + $_[0];
  $y_temp = $servo_y - $servo_l - $servo_mount_y + $drill_r + $_[1];

  &screwHoles($x_temp, $y_temp, 0);
#=cut
}

#++++++++++++++++++++++ Screw holes ++++++++++++++++++++++++++++++++++++
sub screwHoles(){

  my $nut_r = 5.3/2.0 - $drill_r;
  my $r = $nut_r;
  my $nut_depth = -1.9;

  if($_[2] == 0){
    $r = $screw_hole_r;
  }

  $x = $_[0] + sin(0.0) * ($r)/2.0;
  $y = $_[1] + cos(0.0) * ($r)/2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    if($Z_down < $nut_depth && $r == $nut_r){
      $Z_down = $nut_depth;
    }
    $z = $Z_down;
    $feed_rate = $feed_rate_material;
    for($alpha = 0.0; $alpha <= $PI * 2.0; $alpha += 0.01){
      $x = $_[0] + sin($alpha) * $r;
      $y = $_[1] + cos($alpha) * $r;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    }

    if($Z_down == $nut_depth){
      $r = $screw_hole_r;
      $x = $_[0] + sin(0.0) * $r;
      $y = $_[1] + cos(0.0) * $r;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z=$Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

}
