#! /usr/bin/perl

use strict;
use CGI qw(:standard);
use CGI::Carp qw(fatalsToBrowser);
use Math::Trig;

my $i;
my $alpha = 0.0;
my $PI = 3.1415927;
my $x = 0.0;
my $y = 0.0;
my $z = 0.0;
my $factor = 1.00;

my $drill_d = 3.0;
my $drill_r = $drill_d/2.0;
my $gap = 0.005;
my $radius_outer = 16 + $drill_r;
my $radius_screws = 24;
my $Screws_r = (3.0-$drill_d)/2.0;
my $servo_horn_r = 27/2.0;
my $servo_hole_r = 5.0;

my $flap_l = 40;
my $flap_w = 10;

my $bar_gap = 0.75;
my $bar_gap_2 = 0.21;
my $bar_gap_3 = 4;

my $x_distance = $radius_outer;
my $y_distance = $radius_outer;

my $LED_holder_w = 15;
my $screw_hole_r = 2.5 - $drill_r;



my $feed_rate = 1.000;
my $feed_rate_material = 1.500;
my $feed_rate_empty = 3.000;
my $Z_up = 3.000;
my $Z_down = -1.000;
my $Z_down_1 = -1.500;
my $Z_down_2 = -2.000;
my $Z_down_3 = -4.500;
my $z_step = 4.5;
my $z_step_temp = $z_step;

open(FILEOUT,'> camera-holder.gcode') || die "Can not open " . "camera-holder.gcode!\n";


  print FILEOUT "M3\n";
  print FILEOUT "M8\n";


  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  #Bend

  $x = sin(0) * $radius_outer + $flap_w/2;
  $y = cos(0) * $radius_outer;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  if($z_step_temp > -$Z_down_1){
    $z_step_temp = -$Z_down_1;
  }
  for($Z_down = -$z_step_temp; $Z_down >= $Z_down_1; $Z_down -= $z_step_temp){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;



    $x = sin(0) * $radius_outer + $flap_w/2;
    $y = cos(0) * $radius_outer;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = sin(0) * $radius_outer - $flap_w/2;
    $y = cos(0) * $radius_outer;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = sin(0) * $radius_outer - $flap_w/2;
    $y = cos(0) * $radius_outer + $flap_l;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down - $z_step < $Z_down_1 && $Z_down !=  $Z_down_1){
      $Z_down = $Z_down_1 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";




  #LED holes
  for($i = 3; $i > -1; $i--){
    &screwHoles(-($flap_w + $LED_holder_w)/2, $radius_outer + ($i+0.5) * $flap_l/4);
  }




  #Servo horn holes
  for($alpha = 0.0; $alpha < 2.0 * $PI; $alpha += $PI / 2.0){
    my $xr = sin($alpha) * ($servo_horn_r);
    my $yr = cos($alpha) * ($servo_horn_r);
    my $beta = 0.0;

    $z = $Z_up;
    $feed_rate = $feed_rate_empty;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $xr + sin($beta) * $Screws_r;
    $y = $yr + cos($beta) * $Screws_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
      $z = $Z_down;
      $feed_rate = $feed_rate_material;
      for($beta = 0.0; $beta <= 2.0 * $PI; $beta += 0.01){
        $x = $xr + sin($beta) * $Screws_r;
        $y = $yr + cos($beta) * $Screws_r;
        $x = $x * $factor + $x_distance;
        $y = $y * $factor + $y_distance;
        print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      }
      if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
        $Z_down = $Z_down_3 + $z_step;
      }
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  $x = sin(0.0) * $servo_hole_r;
  $y = cos(0.0) * $servo_hole_r;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;
    for($alpha = 0.0; $alpha <= 2.0 * $PI; $alpha += 0.01){
      if($Z_down < $Z_down_2 && ($alpha < $bar_gap || $alpha > $PI*4/3 && $alpha < $PI*4/3 + $bar_gap || $alpha > $PI*2/3 && $alpha < $PI*2/3 + $bar_gap)){
        $z = $Z_down_2;
      }
      else{
        $z = $Z_down;
      }
      $x = sin($alpha) * $servo_hole_r;
      $y = cos($alpha) * $servo_hole_r;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }
    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  #Outer cut line
  $x = sin(0) * $radius_outer - $flap_w/2;
  $y = cos(0) * $radius_outer;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;


    $x = sin(0) * $radius_outer - $flap_w/2;
    $y = cos(0) * $radius_outer;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = sin(0) * $radius_outer - $flap_w/2 - $LED_holder_w;
    $y = cos(0) * $radius_outer;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = sin(0) * $radius_outer - $flap_w/2 - $LED_holder_w;
    $y = cos(0) * $radius_outer + $flap_l;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    $x = sin(0) * $radius_outer - $bar_gap_3/2;
    $y = cos(0) * $radius_outer + $flap_l;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down < $Z_down_2){
      $z = $Z_down_2;
    }

    $x = sin(0) * $radius_outer - $bar_gap_3/2;
    $y = cos(0) * $radius_outer + $flap_l;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = sin(0) * $radius_outer + $bar_gap_3/2;
    $y = cos(0) * $radius_outer + $flap_l;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $z = $Z_down;

    $x = sin(0) * $radius_outer + $bar_gap_3/2;
    $y = cos(0) * $radius_outer + $flap_l;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = sin(0) * $radius_outer + $flap_w/2;
    $y = cos(0) * $radius_outer + $flap_l;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    for($alpha = asin(($flap_w/2)/$radius_outer); $alpha <= 2.0 * $PI - asin(($flap_w/2)/$radius_outer); $alpha += 0.01){
      if($Z_down < $Z_down_2 && ($alpha < $bar_gap_2 || $alpha > $PI*4/3 && $alpha < $PI*4/3 + $bar_gap_2 || $alpha > $PI*2/3 && $alpha < $PI*2/3 + $bar_gap_2)){
        $z = $Z_down_2;
      }
      else{
        $z = $Z_down;
      }
      $x = sin($alpha) * $radius_outer;
      $y = cos($alpha) * $radius_outer;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

#    $y = cos($alpha) * $radius_outer + $flap_l;
#    $y = $y * $factor + $y_distance;
#    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  print FILEOUT "M5\n";
  print FILEOUT "M9\n";


  $x=0.0;
  $y=0.0;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


close(FILEOUT);

#++++++++++++++++++++++ Screw holes ++++++++++++++++++++++++++++++++++++
sub screwHoles(){

  my $nut_r = 5.3/2.0 - $drill_r;
  my $r = $nut_r;
  my $nut_depth = -1.9;

  if($_[2] == 0){
    $r = $screw_hole_r;
  }

  $x = $_[0] + sin(0.0) * ($r)/2.0;
  $y = $_[1] + cos(0.0) * ($r)/2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    if($Z_down < $nut_depth && $r == $nut_r){
      $Z_down = $nut_depth;
    }
    $z = $Z_down;
    $feed_rate = $feed_rate_material;
    for($alpha = 0.0; $alpha <= $PI * 2.0; $alpha += 0.01){
      $x = $_[0] + sin($alpha) * $r;
      $y = $_[1] + cos($alpha) * $r;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    }

    if($Z_down == $nut_depth){
      $r = $screw_hole_r;
      $x = $_[0] + sin(0.0) * $r;
      $y = $_[1] + cos(0.0) * $r;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z=$Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

}
