#! /usr/bin/perl

use strict;

my $i;
my $j;
my $alpha = 0.0;
my $beta = 0.0;
my $PI = 3.1415927;
my $x = 0.0;
my $y = 0.0;
my $z = 0.0;
my $factor = 1.00;

my $x_temp = 0.0;
my $y_temp = 0.0;

#my $drill_d = 1.5;
my $drill_d = 2.99;
my $drill_r = $drill_d/2.0;


#my $cut_gap = 3.0;  #Width of cut gaps, 1.5mm drill
my $cut_gap = 4.5;   #Width of cut gaps, 3.0mm drill
my $cut_gap_2 = 9.0; #Position of cut gap



my $body_l = 200;
my $body_w = 120;
my $body_h = 25;
my $body_h_2 = 10;
my $body_edge = 5;

my $mount_w = 60.0;
my $mount_h = 52.0;
my $mount_flap = 20.0;
my $mount_edge = 5;

my $holes_grid_x = 6;
my $holes_grid_y = 2;

my $servo_l = 41;
my $servo_w = 20;
my $servo_x = 50.0;
my $servo_y = 50.0;
my $servo_cable_w = 6;
my $servo_cable_l = 3;
my $servo_mount_x = ($servo_w - 10.17)/2.0;
my $servo_mount_y = 4.81 - 0.5;
my $screw_hole_r = (3.00-$drill_d)/2.0;

my $rear_axle_x = $body_w/2.0 + $servo_w / 2.0 + $drill_d;
my $rear_axle_y = -$body_l/2.0 + 5.0;
my $rear_axle_l = 25.0;
my $rear_axle_d = 4.0;


my $x_distance = 0.0;
my $y_distance = 0.0;



my $feed_rate = 2.000;
my $feed_rate_material = 1.500;
my $feed_rate_empty = 2.500;
my $Z_up = 3.000;      #Highest point of tool
my $Z_down = -1.000;
my $Z_down_1 = -1.500; #Depth bend edges
my $Z_down_2 = -2.000; #Depth cut edges
my $Z_down_3 = -4.500; #Deepest cut through material
my $z_step = 4.5;      #Cut depth per run
my $z_step_temp = $z_step;

open(FILEOUT,'> camera-servo.gcode') || die "Can not open " . "camera-servo.gcode!\n";


  print FILEOUT "M3\n";#Turn on Spindle
  print FILEOUT "M8\n";#Turn on coolant


  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  $x = 0.0;
  $y = $mount_flap + $drill_r;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


#=pod

  #Bend edges
  print FILEOUT ";Bend edges\n";
  if($z_step_temp > -$Z_down_1){
    $z_step_temp = -$Z_down_1;
  }
  for($Z_down = -$z_step_temp; $Z_down >= $Z_down_1; $Z_down -= $z_step_temp){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;

    $x = 0.0;
    $y = $mount_flap + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $mount_w + $drill_d;
    $y = $mount_flap + $drill_r;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down - $z_step < $Z_down_1 && $Z_down !=  $Z_down_1){
      $Z_down = $Z_down_1 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
#=cut

  #Servo cuts
  print FILEOUT ";Servo cuts\n";
  &Servo(0, 0, 0.5, 0.5);

#=pod

  #Mount holes grid

  for($j=0; $j<$holes_grid_y; $j++){
    for($i=0; $i<$holes_grid_x; $i++){
      $x_temp = ($i + 0.5) * $mount_w / ($holes_grid_x) + $drill_r;
      $y_temp = ($j + 0.5) * $mount_flap / ($holes_grid_y);
      &screwHoles($x_temp, $y_temp, 0);
    }
    $j++;
    if($j<$holes_grid_y){
      for($i=$holes_grid_x-1; $i>-1; $i--){
        $x_temp = ($i + 0.5) * $mount_w / ($holes_grid_x) + $drill_r;
        $y_temp = ($j + 0.5) * $mount_flap / ($holes_grid_y);
        &screwHoles($x_temp, $y_temp, 0);
      }
    }
  }
#=cut

  #Cutting outline
  print FILEOUT ";Outline\n";

  $x = $mount_edge;
  $y = 0.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $feed_rate = $feed_rate_material;
    $z = $Z_down;

    $x = $mount_edge;
    $y = 0.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = 0.0;
    $y = $mount_edge;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = 0.0;
    $y = $mount_h + $mount_flap - $mount_edge + $drill_d;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = $mount_edge;
    $y = $mount_h + $mount_flap + $drill_d;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down < $Z_down_2){#Cut gap

      $x = $mount_w/2.0 - $cut_gap/2.0;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $mount_w/2.0 + $cut_gap/2.0;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $x = $mount_w + $drill_d - $mount_edge;
    $x = $x * $factor + $x_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $mount_h + $mount_flap - $mount_edge + $drill_d;
    $x = $mount_w + $drill_d;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $mount_edge;
    $x = $mount_w + $drill_d;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = 0.0;
    $x = $mount_w + $drill_d - $mount_edge;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down < $Z_down_2){#Cut gap

      $x = $mount_w*3.0/4.0 + $cut_gap/2.0;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $mount_w*3.0/4.0 - $cut_gap/2.0;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down < $Z_down_2){#Cut gap

      $x = $mount_w*1.0/4.0 + $cut_gap/2.0;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $mount_w*1.0/4.0 - $cut_gap/2.0;
      $x = $x * $factor + $x_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $y = 0.0;
    $x = $mount_edge;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";




  #Back to zero
  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "M5\n";#Turn off spindle
  print FILEOUT "M9\n";#Turn off coolant
  $x = 0;
  $y = 0;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";




close(FILEOUT);

exit(0);


#+++++++++++++++++++++++ Servo cut +++++++++++++++++++++++++++++++++++++

sub Servo(){

  #Cutting Servo holes
  $y = $servo_y + $_[1];
  $x = $servo_x + $_[0];
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
  print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $feed_rate = $feed_rate_material;
    $z = $Z_down;

    $y = $servo_y + $_[1];
    $x = $servo_x + $_[0] - $drill_d * $_[2];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down < $Z_down_2){#Cut gap

      $x = $servo_x + $_[0] - $drill_d * $_[2];
      $y = $servo_y - $servo_l/2.0 + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $servo_x + $_[0] - $drill_d * $_[2];
      $y = $servo_y - $servo_l/2.0 - $cut_gap + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $y = $servo_y - $servo_l + $drill_d + $_[1];
    $x = $servo_x + $_[0] - $drill_d * $_[2];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    #cable cut
    $y = $servo_y - $servo_l + $drill_d + $_[1];
    $x = $servo_x + $servo_w - $drill_d - ($servo_w-$servo_cable_w)/2.0 + $_[0];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $servo_y - $servo_l + $drill_d + $_[1] - $servo_cable_l;
    $x = $servo_x + $servo_w - $drill_d - ($servo_w-$servo_cable_w)/2.0 + $_[0];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $servo_y - $servo_l + $drill_d + $_[1] - $servo_cable_l;
    $x = $servo_x + ($servo_w-$servo_cable_w)/2.0 + $_[0];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $y = $servo_y - $servo_l + $drill_d + $_[1];
    $x = $servo_x + ($servo_w-$servo_cable_w)/2.0 + $_[0];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";




    $y = $servo_y - $servo_l + $drill_d + $_[1];
    $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down < $Z_down_2){#Cut gap

      $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];
      $y = $servo_y - $servo_l*4.0/5.0 - $cut_gap + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];;
      $y = $servo_y - $servo_l*4.0/5.0 + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down < $Z_down_2){#Cut gap

      $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];;
      $y = $servo_y - $servo_l/5.0 - $cut_gap + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];;
      $y = $servo_y - $servo_l/5.0 + $drill_d + $_[1];
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
      print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $y = $servo_y + $_[1];
    $x = $servo_x + $servo_w - $drill_d + $_[0] + $drill_d * $_[3];;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";



    $y = $servo_y + $_[1];
    $x = $servo_x + $_[0];
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }


  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  #print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
  print FILEOUT "X" . sprintf("%.3f", $y)  . " Y" . sprintf("%.3f", $x)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

#=pot
  #Holes servo mount
  $x_temp = $servo_x + $servo_mount_x - $drill_r + $_[0];
  $y_temp = $servo_y + $servo_mount_y + $drill_r + $_[1];

  #&screwHoles($x_temp, $y_temp, 0);
  &screwHoles($y_temp, $x_temp, 0);

  #Holes servo mount
  $x_temp = $servo_x + $servo_w - $servo_mount_x - $drill_r + $_[0];
  $y_temp = $servo_y + $servo_mount_y + $drill_r + $_[1];

  #&screwHoles($x_temp, $y_temp, 0);
  &screwHoles($y_temp, $x_temp, 0);

  #Holes servo mount
  $x_temp = $servo_x + $servo_w - $servo_mount_x - $drill_r + $_[0];
  $y_temp = $servo_y - $servo_l - $servo_mount_y + $drill_r + $_[1];

  #&screwHoles($x_temp, $y_temp, 0);
  &screwHoles($y_temp, $x_temp, 0);

  #Holes servo mount
  $x_temp = $servo_x + $servo_mount_x - $drill_r + $_[0];
  $y_temp = $servo_y - $servo_l - $servo_mount_y + $drill_r + $_[1];

  #&screwHoles($x_temp, $y_temp, 0);
  &screwHoles($y_temp, $x_temp, 0);
#=cut
}

#++++++++++++++++++++++ Screw holes ++++++++++++++++++++++++++++++++++++
sub screwHoles(){

  my $nut_r = 5.3/2.0 - $drill_r;
  my $r = $nut_r;
  my $nut_depth = -1.9;

  if($_[2] == 0){
    $r = $screw_hole_r;
  }

  $x = $_[0] + sin(0.0) * ($r)/2.0;
  $y = $_[1] + cos(0.0) * ($r)/2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    if($Z_down < $nut_depth && $r == $nut_r){
      $Z_down = $nut_depth;
    }
    $z = $Z_down;
    $feed_rate = $feed_rate_material;
    for($alpha = 0.0; $alpha <= $PI * 2.0; $alpha += 0.01){
      $x = $_[0] + sin($alpha) * $r;
      $y = $_[1] + cos($alpha) * $r;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    }

    if($Z_down == $nut_depth){
      $r = $screw_hole_r;
      $x = $_[0] + sin(0.0) * $r;
      $y = $_[1] + cos(0.0) * $r;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z=$Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

}
