#! /usr/bin/perl

use strict;

my $i;
my $alpha = 0.0;
my $PI = 3.1415927;
my $x = 0.0;
my $y = 0.0;
my $z = 0.0;
my $factor = 1.00;

my $x_temp = 0.0;
my $y_temp = 0.0;

#my $drill_d = 1.5;
my $drill_d = 2.99;
my $drill_r = $drill_d/2.0;

my $chain_width = 37.0; #Inner chain link
#my $chain_width = 44.0; #Outer chain link
my $chain_h = 10.0;
my $chain_l = 19.5;
my $chain_link = 10.0;
my $chain_hole_1 = 7.0-$drill_d; #Inner chain link
#my $chain_hole_1 = 3.0-$drill_d; #Outer chain link

#my $cut_gap = 3.0;  #Width of cut gaps, 1.5mm drill
my $cut_gap = 4.5;   #Width of cut gaps, 3.0mm drill
my $cut_gap_2 = 9.0; #Position of cut gap


my $x_distance = ($chain_l + $chain_h)/2.0 + $drill_r;
my $y_distance = $chain_width/2.0 + $chain_h + $drill_r;



my $feed_rate = 2.000;
my $feed_rate_material = 1.500;
my $feed_rate_empty = 2.500;
my $Z_up = 3.000;      #Highest point of tool
my $Z_down = -1.000;
my $Z_down_1 = -1.500; #Depth bend edges
my $Z_down_2 = -2.000; #Depth cut edges
my $Z_down_3 = -4.500; #Deepest cut through material
my $z_step = 4.5;      #Cut depth per run
my $z_step_temp = $z_step;

open(FILEOUT,'> chain.gcode') || die "Can not open " . "chain.gcode!\n";


  print FILEOUT "M3\n";#Turn on Spindle
  print FILEOUT "M8\n";#Turn on coolant


  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  $x = ($chain_link + $drill_d) / 2.0;
  $y = ($chain_width - $drill_d) /2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  #Bend edge
  if($z_step_temp > -$Z_down_1){
    $z_step_temp = -$Z_down_1;
  }
  for($Z_down = -$z_step_temp; $Z_down >= $Z_down_1; $Z_down -= $z_step_temp){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;

    $x = ($chain_link + $drill_d) / 2.0;
    $y = ($chain_width - $drill_d) /2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = -($chain_link + $drill_d) / 2.0;
    $y = ($chain_width - $drill_d) /2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($drill_d == 1.5){
      $x = -($chain_link + $drill_d) / 2.0;
      $y = ($chain_width)/2.0 - $drill_d*0.75;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = ($chain_link + $drill_d) / 2.0;
      $y = ($chain_width)/2.0 - $drill_d*0.75;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = ($chain_link + $drill_d) / 2.0;
      $y = ($chain_width)/2.0 - $drill_d*1.5;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = -($chain_link + $drill_d) / 2.0;
      $y = ($chain_width)/2.0 - $drill_d*1.5;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = -($chain_link + $drill_d) / 2.0;
      $y = ($chain_width)/2.0 - $drill_d*2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = ($chain_link + $drill_d) / 2.0;
      $y = ($chain_width)/2.0 - $drill_d*2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }
    if($Z_down - $z_step < $Z_down_1 && $Z_down !=  $Z_down_1){
      $Z_down = $Z_down_1 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  $x = ($chain_link + $drill_d) / 2.0;
  $y = -($chain_width - $drill_d) /2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step_temp; $Z_down >= $Z_down_1; $Z_down -= $z_step_temp){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;

    $x = ($chain_link + $drill_d) / 2.0;
    $y = -($chain_width - $drill_d) /2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = -($chain_link + $drill_d) / 2.0;
    $y = -($chain_width - $drill_d) /2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($drill_d == 1.5){
      $x = -($chain_link + $drill_d) / 2.0;
      $y = -($chain_width)/2.0 + $drill_d*0.75;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = ($chain_link + $drill_d) / 2.0;
      $y = -($chain_width)/2.0 + $drill_d*0.75;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = ($chain_link + $drill_d) / 2.0;
      $y = -($chain_width)/2.0 + $drill_d*1.5;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = -($chain_link + $drill_d) / 2.0;
      $y = -($chain_width)/2.0 + $drill_d*1.5;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = -($chain_link + $drill_d) / 2.0;
      $y = -($chain_width)/2.0 + $drill_d*2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = ($chain_link + $drill_d) / 2.0;
      $y = -($chain_width)/2.0 + $drill_d*2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down - $z_step < $Z_down_1 && $Z_down !=  $Z_down_1){
      $Z_down = $Z_down_1 + $z_step;
    }
  }

  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


  #Holes
  $x_temp = ($chain_l + $drill_d) / 2.0;
  $y_temp = ($chain_width + $chain_h) /2.0;
  $x = $x_temp + sin(0.0) * ($chain_hole_1)/2.0;
  $y = $y_temp + cos(0.0) * ($chain_hole_1)/2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;
    for($alpha = 0.0; $alpha <= $PI * 2.0; $alpha += 0.01){
      $x = $x_temp + sin($alpha) * ($chain_hole_1)/2.0;
      $y = $y_temp + cos($alpha) * ($chain_hole_1)/2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    }
    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }
  $z=$Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


  $x_temp = -($chain_l + $drill_d) / 2.0;
  $y_temp = ($chain_width + $chain_h) /2.0;

  $x = $x_temp + sin($alpha) * ($chain_hole_1)/2.0;
  $y = $y_temp + cos($alpha) * ($chain_hole_1)/2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;
    for($alpha = 0.0; $alpha <= $PI * 2.0; $alpha += 0.01){
      $x = $x_temp + sin($alpha) * ($chain_hole_1)/2.0;
      $y = $y_temp + cos($alpha) * ($chain_hole_1)/2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }
    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z=$Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  $x_temp = -($chain_l + $drill_d) / 2.0;
  $y_temp = -($chain_width + $chain_h) /2.0;

  $x = $x_temp + sin($alpha) * ($chain_hole_1)/2.0;
  $y = $y_temp + cos($alpha) * ($chain_hole_1)/2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;
    for($alpha = 0.0; $alpha <= $PI * 2.0; $alpha += 0.01){
      $x = $x_temp + sin($alpha) * ($chain_hole_1)/2.0;
      $y = $y_temp + cos($alpha) * ($chain_hole_1)/2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }
    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }

  $z=$Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  $x_temp = ($chain_l + $drill_d) / 2.0;
  $y_temp = -($chain_width + $chain_h) /2.0;

  $x = $x_temp + sin($alpha) * ($chain_hole_1)/2.0;
  $y = $y_temp + cos($alpha) * ($chain_hole_1)/2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $z = $Z_down;
    $feed_rate = $feed_rate_material;
    for($alpha = 0.0; $alpha <= $PI * 2.0; $alpha += 0.01){
      $x = $x_temp + sin($alpha) * ($chain_hole_1)/2.0;
      $y = $y_temp + cos($alpha) * ($chain_hole_1)/2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }
    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }


  $z=$Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


  #Chain link
  $x = ($chain_link + $drill_d) / 2.0;
  $y = -($chain_width - $drill_d) /2.0;
  $x = $x * $factor + $x_distance;
  $y = $y * $factor + $y_distance;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  for($Z_down = -$z_step; $Z_down >= $Z_down_3; $Z_down -= $z_step){
    $feed_rate = $feed_rate_material;
    $z = $Z_down;

    $x = ($chain_link + $drill_d) / 2.0;
    $y = -($chain_width - $drill_d) /2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = ($chain_link + $drill_d) / 2.0;
    $y = ($chain_width - $drill_d) /2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = ($chain_l + $drill_d) / 2.0;
    $y = ($chain_width - $drill_d) /2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x_temp = ($chain_l + $drill_d) / 2.0;
    $y_temp = ($chain_width + $chain_h) /2.0;
    for($alpha = $PI; $alpha >= 0.0; $alpha -= 0.01){
      $x = $x_temp + sin($alpha) * ($chain_h + $drill_d)/2.0;
      $y = $y_temp + cos($alpha) * ($chain_h + $drill_d)/2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    }

    if($Z_down < $Z_down_2){

      $x = ($cut_gap) / 2.0;
      $y = ($chain_width + $drill_d)/2.0 + $chain_h;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = -($cut_gap) / 2.0;
      $y = ($chain_width + $drill_d)/2.0 + $chain_h;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $x = -($chain_l + $drill_d) / 2.0;
    $y = ($chain_width + $drill_d)/2.0 + $chain_h;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x_temp = -($chain_l + $drill_d) / 2.0;
    $y_temp = ($chain_width + $chain_h) /2.0;
    for($alpha = 0.0; $alpha >= -$PI; $alpha -= 0.01){
      $x = $x_temp + sin($alpha) * ($chain_h + $drill_d)/2.0;
      $y = $y_temp + cos($alpha) * ($chain_h + $drill_d)/2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $x = -($chain_link + $drill_d) / 2.0;
    $y = ($chain_width - $drill_d) /2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = -($chain_link + $drill_d) / 2.0;
    $y = -($chain_width - $drill_d) /2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x = -($chain_l + $drill_d) / 2.0;
    $y = -($chain_width - $drill_d) /2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


    $x_temp = -($chain_l + $drill_d) / 2.0;
    $y_temp = -($chain_width + $chain_h) /2.0;
    for($alpha = 0.0; $alpha >= -$PI; $alpha -= 0.01){
      $x = $x_temp + sin($alpha) * ($chain_h + $drill_d)/2.0;
      $y = $y_temp + cos($alpha) * ($chain_h + $drill_d)/2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down < $Z_down_2){

      $x = -($cut_gap) / 2.0 - $cut_gap_2;
      $y = -($chain_width + $drill_d)/2.0 - $chain_h;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = ($cut_gap) / 2.0 - $cut_gap_2;
      $y = -($chain_width + $drill_d)/2.0 - $chain_h;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    if($Z_down < $Z_down_2){

      $x = -($cut_gap) / 2.0 + $cut_gap_2;
      $y = -($chain_width + $drill_d)/2.0 - $chain_h;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down_2;

      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $x = ($cut_gap) / 2.0 + $cut_gap_2;
      $y = -($chain_width + $drill_d)/2.0 - $chain_h;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

      $z = $Z_down;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";
    }

    $x = ($chain_l + $drill_d) / 2.0;
    $y = -(($chain_width + $drill_d)/2.0 + $chain_h);
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    $x_temp = ($chain_l + $drill_d) / 2.0;
    $y_temp = -($chain_width + $chain_h) /2.0;
    for($alpha = $PI; $alpha >= 0.0; $alpha -= 0.01){
      $x = $x_temp + sin($alpha) * ($chain_h + $drill_d)/2.0;
      $y = $y_temp + cos($alpha) * ($chain_h + $drill_d)/2.0;
      $x = $x * $factor + $x_distance;
      $y = $y * $factor + $y_distance;
      print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    }

    $x = ($chain_link + $drill_d) / 2.0;
    $y = -($chain_width - $drill_d)/2.0;
    $x = $x * $factor + $x_distance;
    $y = $y * $factor + $y_distance;
    print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

    if($Z_down - $z_step < $Z_down_3 && $Z_down !=  $Z_down_3){
      $Z_down = $Z_down_3 + $z_step;
    }
  }


  $z = $Z_up;
  $feed_rate = $feed_rate_empty;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";

  print FILEOUT "M5\n";#Turn off spindle
  print FILEOUT "M9\n";#Turn off coolant


  $x=0.0;
  $y=0.0;
  print FILEOUT "X" . sprintf("%.3f", $x)  . " Y" . sprintf("%.3f", $y)  .  " Z" . sprintf("%.3f", $z)  . " F" . sprintf("%.3f", $feed_rate)  . "\n";


close(FILEOUT);
